package moe.jansel.platinum

import io.ktor.client.*
import io.ktor.client.engine.cio.*
import io.ktor.client.plugins.*
import io.ktor.client.plugins.contentnegotiation.*
import io.ktor.serialization.kotlinx.json.*
import io.papermc.paper.command.brigadier.Commands
import io.papermc.paper.plugin.lifecycle.event.LifecycleEventManager
import io.papermc.paper.plugin.lifecycle.event.types.LifecycleEvents
import kotlinx.serialization.json.Json
import org.bukkit.Server
import org.bukkit.command.CommandExecutor
import org.bukkit.command.PluginCommand
import org.bukkit.command.TabCompleter
import org.bukkit.plugin.Plugin
import org.bukkit.plugin.PluginManager
import org.bukkit.plugin.java.JavaPlugin
import org.bukkit.scheduler.BukkitScheduler
import java.util.Properties
import java.util.logging.Logger

@Suppress("unused")
class Platinum : JavaPlugin() {
    companion object {
        lateinit var instance: Platinum
        lateinit var pluginManager: PluginManager
        lateinit var logger: Logger
        lateinit var server: Server
        lateinit var props: Properties
        lateinit var version: String
        lateinit var hash: String
        lateinit var webClient: HttpClient
    }



    override fun onEnable() {

    }

    override fun onLoad() {
        props = Properties()
        props.load(getResource("build-vars.properties"))
        version = props.getProperty("version")
        hash = props.getProperty("gitCommit")
        logger.info("Loading Platinum v$version")
        if (version.contains("SNAPSHOT")) {
            logger.info("Git Commit: $hash")
        }
        webClient = HttpClient(CIO) {
            install(ContentNegotiation) {
                json(Json { ignoreUnknownKeys = true })
            }
            install(UserAgent) {
                agent = "https://git.jansel.moe/jreimers/Platinum v$version(jansel@jansel.moe)"
            }
        }
        Companion.server = server
        pluginManager = server.pluginManager
        instance = this
    }

    override fun onDisable() {
        // Plugin shutdown logic
    }

    private fun registerCommands() {

    }

    private fun String.cmd() = instance.getCommand(this) ?: throw NullPointerException("Command '$name' not found!")
    private infix fun PluginCommand.complete(with: TabCompleter) { this.tabCompleter = with }
    private infix fun PluginCommand.execs(thing: CommandExecutor) = this.also { setExecutor(thing) }
}
